using RMYY_CallCenter_Api.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RMYY_CallCenter_Api.Dal
{

    /// <summary>
    /// 数据访问类:T_Sys_Role
    /// </summary>
    public partial class T_Sys_Role
    {
        public T_Sys_Role()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string F_RoleCode)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_Role");
            strSql.Append(" where F_RoleCode=@F_RoleCode");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleCode", SqlDbType.VarChar,50)
            };
            parameters[0].Value = F_RoleCode;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(RMYY_CallCenter_Api.Model.T_Sys_Role model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_Role(");
            strSql.Append("F_RoleCode,F_RoleName,F_Sort,F_Remark,F_State,F_CreateUser,F_CreateTime)");
            strSql.Append(" values (");
            strSql.Append("@F_RoleCode,@F_RoleName,@F_Sort,@F_Remark,@F_State,@F_CreateUser,@F_CreateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_RoleName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,255),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.F_RoleCode;
            parameters[1].Value = model.F_RoleName;
            parameters[2].Value = model.F_Sort;
            parameters[3].Value = model.F_Remark;
            parameters[4].Value = model.F_State;
            parameters[5].Value = model.F_CreateUser;
            parameters[6].Value = model.F_CreateTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(RMYY_CallCenter_Api.Model.T_Sys_Role model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_Role set ");
            strSql.Append("F_RoleCode=@F_RoleCode,");
            strSql.Append("F_RoleName=@F_RoleName,");
            strSql.Append("F_Sort=@F_Sort,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_CreateTime=@F_CreateTime");
            strSql.Append(" where F_RoleId=@F_RoleId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_RoleName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,255),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_RoleId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_RoleCode;
            parameters[1].Value = model.F_RoleName;
            parameters[2].Value = model.F_Sort;
            parameters[3].Value = model.F_Remark;
            parameters[4].Value = model.F_State;
            parameters[5].Value = model.F_CreateUser;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_RoleId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_RoleId)
        {
            string sql1 = "delete from T_Sys_Role where F_RoleId = " + F_RoleId;
            string sql2 = "delete from T_Sys_RoleMenu where F_RoleId = " + F_RoleId;
            List<string> list = new List<string>() { sql1, sql2 };
            int rows = DbHelperSQL.ExecuteSqlTran(list);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_RoleIdlist)
        {
            string sql1 = "delete from T_Sys_Role where F_RoleId in (" + F_RoleIdlist + ") ";
            string sql2 = "delete from T_Sys_RoleMenu where F_RoleId in (" + F_RoleIdlist + ") ";
            List<string> list = new List<string>() { sql1, sql2 };
            int rows = DbHelperSQL.ExecuteSqlTran(list);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Sys_Role GetModel(int F_RoleId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_RoleId,F_RoleCode,F_RoleName,F_Sort,F_Remark,F_State,F_CreateUser,F_CreateTime from T_Sys_Role with(nolock)");
            strSql.Append(" where F_RoleId=@F_RoleId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_RoleId;

            RMYY_CallCenter_Api.Model.T_Sys_Role model = new RMYY_CallCenter_Api.Model.T_Sys_Role();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Sys_Role GetModel(string F_RoleCode)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_RoleId,F_RoleCode,F_RoleName,F_Sort,F_Remark,F_State,F_CreateUser,F_CreateTime from T_Sys_Role with(nolock)");
            strSql.Append(" where F_RoleCode=@F_RoleCode");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleCode", SqlDbType.VarChar,50)
            };
            parameters[0].Value = F_RoleCode;

            RMYY_CallCenter_Api.Model.T_Sys_Role model = new RMYY_CallCenter_Api.Model.T_Sys_Role();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Sys_Role DataRowToModel(DataRow row)
        {
            RMYY_CallCenter_Api.Model.T_Sys_Role model = new RMYY_CallCenter_Api.Model.T_Sys_Role();
            if (row != null)
            {
                if (row["F_RoleId"] != null && row["F_RoleId"].ToString() != "")
                {
                    model.F_RoleId = int.Parse(row["F_RoleId"].ToString());
                }
                if (row["F_RoleCode"] != null)
                {
                    model.F_RoleCode = row["F_RoleCode"].ToString();
                }
                if (row["F_RoleName"] != null)
                {
                    model.F_RoleName = row["F_RoleName"].ToString();
                }
                if (row["F_Sort"] != null && row["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(row["F_Sort"].ToString());
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_RoleId,F_RoleCode,F_RoleName,F_Sort,F_Remark,F_State,F_CreateUser,F_CreateTime ");
            strSql.Append(" FROM T_Sys_Role with(nolock)");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_RoleId,F_RoleCode,F_RoleName,F_Sort,F_Remark,F_State,F_CreateUser,F_CreateTime ");
            strSql.Append(" FROM T_Sys_Role with(nolock)");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_Role with(nolock)");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }

        #endregion  BasicMethod
    }
}
